# TranslatorFactory Class Reference

An unidirectional data translator (codec). More...

`#include <yatephone.h>`

Inheritance diagram for TranslatorFactory:

List of all members.

## Public Member Functions

virtual | ~TranslatorFactory ()
virtual void | removed (const TranslatorFactory *factory)
virtual DataTranslator * | create (const DataFormat &sFormat, const DataFormat &dFormat)=0
virtual const TranslatorCaps * | getCapabilities () const=0
virtual bool | converts (const DataFormat &sFormat, const DataFormat &dFormat) const
virtual unsigned int | length () const
virtual bool | intermediate (const FormatInfo *info) const
virtual const FormatInfo * | intermediate () const

## Protected Member Functions

| TranslatorFactory ()

## Detailed Description

An unidirectional data translator (codec).

A factory for constructing data translators by format name conversion of data from one type to another

## Constructor & Destructor Documentation

TranslatorFactory | ( |  | ) | `[inline, protected]`

Constructor - registers the factory in the global list

virtual ~TranslatorFactory | ( |  | ) | `[virtual]`

Destructor - unregisters from the global list

## Member Function Documentation

virtual void removed | ( | const TranslatorFactory * | factory | ) | `[virtual]`

Notification that another factory was removed from the list

Parameters:

  | factory | Pointer to the factory that just got removed

virtual DataTranslator* create | ( | const DataFormat & | sFormat,
|  | const DataFormat & | dFormat |
| ) |  |  | `[pure virtual]`

Creates a translator given the source and destination format names

Parameters:

  | sFormat | Name of the source format (data received from the consumer)
  | dFormat | Name of the destination format (data supplied to the source)

Returns:
  A pointer to the end of a DataTranslator chain or NULL

virtual const TranslatorCaps* getCapabilities | ( |  | ) | const`[pure virtual]`

Get the capabilities table of this translator

Returns:
  A pointer to the first element of the capabilities table

virtual bool converts | ( | const DataFormat & | sFormat,
|  | const DataFormat & | dFormat |
| ) |  |  | const`[virtual]`

Check if this factory can build a translator for given data formats

Parameters:

  | sFormat | Name of the source format
  | dFormat | Name of the destination format

Returns:
  True if a conversion between formats is possible

virtual unsigned int length | ( |  | ) | const`[virtual]`

Get the length of the translator chain built by this factory

Returns:
  How many translators will build the factory

virtual bool intermediate | ( | const FormatInfo * | info | ) | const`[virtual]`

Check if a data format is used as intermediate in a translator chain

Parameters:

  | info | Format to check for

Returns:
  True if the format is used internally as intermediate

virtual const FormatInfo* intermediate | ( |  | ) | const`[virtual]`

Get the intermediate format used by a translator chain

Returns:
  Pointer to intermediate format or NULL

The documentation for this class was generated from the following file:

- yatephone.h